﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WindowsFormsApplication19
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.PopulateData();

            this.ultraMaskedEdit1.InputMask = "##-#######";
            this.ultraMaskedEdit2.InputMask = "###-##-####";
        }

        private void PopulateData()
        {
            for (int i = 0; i < 10; i++)
            {
                this.ultraDataSource1.Rows.Add(new object[] { (i % 2) == 0, 123456789});
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];            
            band.Columns["ID Number"].UseEditorMaskSettings = true;
            band.Columns["ID Number"].MaskDisplayMode = Infragistics.Win.UltraWinMaskedEdit.MaskMode.IncludeBoth;           
        }

        private void ultraGrid1_InitializeRow(object sender, Infragistics.Win.UltraWinGrid.InitializeRowEventArgs e)
        {            
            this.UpdateIDEditor(e.Row);
        }

        private void UpdateIDEditor(UltraGridRow row)
        {
            bool IdType = (bool)row.Cells["ID Type"].Value;
            this.UpdateIDEditor(row, IdType);
        }
        private void UpdateIDEditor(UltraGridRow row, bool IdType)
        {
            if (true == IdType)
                row.Cells["ID Number"].EditorComponent = this.ultraMaskedEdit1;
            else
                row.Cells["ID Number"].EditorComponent = this.ultraMaskedEdit2;
        }

        private void ultraGrid1_CellChange(object sender, CellEventArgs e)
        {
            if (e.Cell.Column.Key == "ID Type")
            {
                // The Value of the cell will not be updated at this point, so we 
                // must use the Text. 
                bool value = bool.Parse(e.Cell.Text);
                this.UpdateIDEditor(e.Cell.Row, value);
            }
        }

        
    }
}
